; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include filtinpt.inc        ; local includes for this file

      EditSl PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
      EditslProc PROTO :DWORD,:DWORD,:DWORD,:DWORD


    .data?
      hEditsl dd ?
      lpEditslProc dd ?

.code

start:

; 

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   rv(GetModuleHandle, NULL)
      mov CommandLine, rv(GetCommandLine)
      mov hIcon,       rv(LoadIcon,hInstance,500)
      mov hCursor,     rv(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        rv(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        rv(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"Subclass_Edit_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

    mov Wwd, 300
    mov Wht, 250
    invoke TopXY,Wwd,sWid
    mov Wtx, eax
    invoke TopXY,Wht,sHgt
    mov Wty, eax

    invoke CreateWindowEx,WS_EX_LEFT or WS_EX_ACCEPTFILES,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

    invoke EditSl,0,20,20,250,25,hWnd,700
    mov hEditsl, eax

    invoke SetWindowLong,hEditsl,GWL_WNDPROC,EditslProc
    mov lpEditslProc, eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp jumpin

    StartLoop:
      invoke TranslateMessage, esi
    ; --------------------------------------
    ; perform any required key processing here
    ; --------------------------------------
      invoke DispatchMessage,  esi
    jumpin:
      invoke GetMessage,esi,edi,edi,edi
      test eax, eax
      jnz StartLoop

    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL fname  :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[260]:BYTE  ; these are two spare buffers
    LOCAL buffer2[260]:BYTE  ; for text manipulation etc..

    Switch uMsg
      Case WM_COMMAND

      Case WM_DROPFILES
        mov fname, DropFileName(wParam)
        fn MessageBox,hWin,fname,"WM_DROPFILES",MB_OK

      case WM_SETFOCUS
        invoke SetFocus,hEditsl

      Case WM_CREATE

      Case WM_SYSCOLORCHANGE

      Case WM_SIZE

      Case WM_CLOSE

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

EditSl proc szMsg:DWORD,a:DWORD,b:DWORD,
               wd:DWORD,ht:DWORD,hParent:DWORD,ID:DWORD

    szText slEdit,"EDIT"

    fn CreateWindowEx,WS_EX_CLIENTEDGE,"EDIT",szMsg, \
           WS_VISIBLE or WS_CHILDWINDOW or \
           ES_AUTOHSCROLL or ES_NOHIDESEL, \
           a,b,wd,ht,hParent,ID,hInstance,NULL

    ret

EditSl endp

; 

EditslProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL pbuf  :DWORD
    LOCAL buffer[260]:BYTE
    LOCAL tbuf  :DWORD
    LOCAL buffr2[260]:BYTE
    LOCAL sbuf  :DWORD
    LOCAL sbuffr[32]:BYTE
    LOCAL rval  :DWORD

    .if uMsg == WM_CHAR

      .if wParam == 46                          ; "."
        mov pbuf, ptr$(buffer)
        invoke GetWindowText,hWin,pbuf,260
        mov rval, rv(InString,1,pbuf,".")       ; only allow one period
        .if rval != 0
          xor eax, eax                          ; throw extra away
          ret
        .endif
        jmp charOK

      .elseif wParam == 8                       ; allow backspace
        jmp charOK

      .elseif wParam == 43                      ; "+"
        mov pbuf, ptr$(buffer)
        invoke GetWindowText,hWin,pbuf,260

        mov pbuf, left$(pbuf,1)

        fn szCmp,pbuf,"-"
        .if eax == 0
          xor eax, eax                          ; throw char away
          ret
        .else
          mov pbuf, ptr$(buffer)
          invoke GetWindowText,hWin,pbuf,260
          add pbuf, 1
          fn SetWindowText,hWin,pbuf
          fn SendMessage,hWin,WM_KEYDOWN,VK_END,0   ; set cursor at end of text
          fn SendMessage,hWin,EM_SETSEL,-1,64

          xor eax, eax                          ; throw char away
          ret
        .endif

      .elseif wParam == 45                      ; "_"
        mov pbuf, ptr$(buffer)
        invoke GetWindowText,hWin,pbuf,260

        mov pbuf, left$(pbuf,1)                 ; get the left character
        fn szCmp,pbuf,"-"                       ; test if its a minus sign

        .if eax != 0                            ; if its a minus sign, exit
          xor eax, eax                          ; throw char away
          ret
        .else
          mov sbuf, ptr$(sbuffr)                ; small buffer for number
          mov pbuf, ptr$(buffer)                ; main output buffer
          mov tbuf, ptr$(buffr2)                ; temporary buffer

          mov sbuf, cat$(sbuf,"-")              ; write minus sign to small buffer

          invoke GetWindowText,hWin,tbuf,260    ; put edit text into temporary buffer
          mov pbuf, cat$(pbuf,sbuf,tbuf)        ; append edit text to minus sign

          fn SetWindowText,hWin,pbuf            ; reset content of edit text

          fn SendMessage,hWin,WM_KEYDOWN,VK_END,0   ; set cursor at end of text

          xor eax, eax                          ; throw char away
          ret

        .endif

      .elseif wParam < "0"                      ; throw away below ASCII "0"
        xor eax, eax
        ret

      .elseif wParam > "9"                      ; throw away above ASCII "9"
        xor eax, eax
        ret

    ; --------------------------------------------------------------------
    ; this block ensures that you cannot enter a digit before the "-" sign
    ; --------------------------------------------------------------------
      .elseif wParam >= "0" && wParam <= "9"
        fn SendMessage,hWin,EM_GETSEL,0,0           ; get the selection start pos
        movzx eax, ax                               ; zero extend it
        .if eax == 0                                ; if its at pos 0
          mov pbuf, ptr$(buffer)
          invoke GetWindowText,hWin,pbuf,260
          mov pbuf, left$(pbuf,1)
          fn szCmp,pbuf,"-"                         ; test if its a minus sign
          .if eax != 0                              ; if its a minus sign, exit
            fn SendMessage,hWin,WM_KEYDOWN,VK_RIGHT,0   ; set cursor one char right
          .endif
        .endif
      .endif

    .endif

    charOK:
    invoke CallWindowProc,lpEditslProc,hWin,uMsg,wParam,lParam

    ret

EditslProc endp

; 

end start
